/* 
 * File:   joystick.h
 * Author: Sankichi
 *
 * Created on 2016/07/27, 21:17
 */

//#define Enable_PS
//#define Output_PS3 /* vXe3VԂ̂ɓKݒBȂNintendo Switch */

#ifndef JOYSTICK_H
#define	JOYSTICK_H

#include <stdint.h>
#include <system.h>

#ifdef	__cplusplus
extern "C" {
#endif

/** TYPE DEFINITIONS ************************************************/
typedef union _INTPUT_CONTROLS_TYPEDEF
{
    struct
    {
        struct
        {
            uint8_t button01_square:1;
            uint8_t button02_x:1;
            uint8_t button03_o:1;
            uint8_t button04_triangle:1;
            uint8_t button05_L1:1;
            uint8_t button06_R1:1;
            uint8_t button07_L2:1;
            uint8_t button08_R2:1;//
            uint8_t button09_select:1;
            uint8_t button10_start:1;
            uint8_t button11_left_stick:1;
            uint8_t button12_right_stick:1;
            uint8_t button13_home:1;
            //uint8_t :3;  // filler
            
            uint8_t button14_unknown:1;  // for Nintendo Switch
            uint8_t button15_unknown:1;  // for Nintendo Switch
            uint8_t button16_unknown:1;  // for Nintendo Switch
            
        } buttons;
        struct
        {
            uint8_t hat_switch:4;
            uint8_t :4;//filler
        } hat_switch;
        struct
        {
            uint8_t X;
            uint8_t Y;
            uint8_t Z;
            uint8_t Rz;
        } analog_stick;
        struct
        {
            uint8_t d00;
        } filler;
    } members;
    //uint8_t val[7];
    uint8_t val[8];
} INPUT_CONTROLS;

#if defined(FIXED_ADDRESS_MEMORY)
    #if defined(COMPILER_MPLAB_C18)
        #pragma udata JOYSTICK_DATA=JOYSTICK_DATA_ADDRESS
            extern INPUT_CONTROLS joystick_input;
        #pragma udata
    #elif defined(__XC8)
        extern INPUT_CONTROLS joystick_input @ JOYSTICK_DATA_ADDRESS;
    #endif
#else
    extern INPUT_CONTROLS joystick_input;
#endif

#define BTNBIT_01	0x00000001
#define BTNBIT_02	0x00000002
#define BTNBIT_03	0x00000004
#define BTNBIT_04       0x00000008
#define BTNBIT_05	0x00000010
#define BTNBIT_06	0x00000020
#define BTNBIT_07	0x00000040
#define BTNBIT_08	0x00000080
#define BTNBIT_09	0x00000100
#define BTNBIT_10	0x00000200
#define BTNBIT_11	0x00000400
#define BTNBIT_12	0x00000800
#define BTNBIT_13	0x00001000
#define BTNBIT_14	0x00002000  /* for Nintendo Switch */
#define BTNBIT_15	0x00004000  /* for Nintendo Switch */
#define BTNBIT_16	0x00008000  /* for Nintendo Switch */

/* for Nintendo Switch */
#define BTNBIT_NSW_Y        BTNBIT_01
#define BTNBIT_NSW_B        BTNBIT_02
#define BTNBIT_NSW_A        BTNBIT_03
#define BTNBIT_NSW_X        BTNBIT_04
#define BTNBIT_NSW_LT       BTNBIT_05
#define BTNBIT_NSW_RT       BTNBIT_06
#define BTNBIT_NSW_ZL       BTNBIT_07
#define BTNBIT_NSW_ZR       BTNBIT_08
#define BTNBIT_NSW_MINUS    BTNBIT_09
#define BTNBIT_NSW_PLUS     BTNBIT_10
#define BTNBIT_NSW_L3       BTNBIT_11
#define BTNBIT_NSW_R3       BTNBIT_12
#define BTNBIT_NSW_HOME     BTNBIT_13
#define BTNBIT_NSW_CAPTURE  BTNBIT_14

#define DEVTYPE_UNKNOWN     0
#define DEVTYPE_FAMICOM     1
#define DEVTYPE_MD          2
#define DEVTYPE_SS          3
#define DEVTYPE_KABUTOGANI  4
#define DEVTYPE_PS          5


#define WAIT_PORTSET        Delay100TCYx(150)
#define IN_SEL_ANALOG_HAT   PORTCbits.RC7
#define IN_RAPPIDSET        PORTBbits.RB4

/** DECLARATIONS ***************************************************/
//http://www.microsoft.com/whdc/archive/hidgame.mspx
#define HAT_SWITCH_NORTH            0x0
#define HAT_SWITCH_NORTH_EAST       0x1
#define HAT_SWITCH_EAST             0x2
#define HAT_SWITCH_SOUTH_EAST       0x3
#define HAT_SWITCH_SOUTH            0x4
#define HAT_SWITCH_SOUTH_WEST       0x5
#define HAT_SWITCH_WEST             0x6
#define HAT_SWITCH_NORTH_WEST       0x7
#define HAT_SWITCH_NULL             0x8

#define ANALOG_NEUTRAL              0x80    // Switch̃Gc[Q[łȂΉ

// http://html5gamepad.com/
// 0x00(0b0000) -> -1.000000
// 0x01(0b0001) -> -0.714286
// 0x02(0b0010) -> -0.428571
// 0x03(0b0011) -> -0.142857
// 0x04(0b0100) ->  0.142857
// 0x05(0b0101) ->  0.428571
// 0x06(0b0110) ->  0.714286
// 0x07(0b0111) ->  1.000000
// 0x08(0b1000) ->  1.285714
// 0x09(0b1001) ->  1.571429
// 0x0a(0b1010) ->  1.857143
// 0x0b(0b1011) ->  2.142857
// 0x0c(0b1100) ->  2.428571
// 0x0d(0b1101) ->  2.714286
// 0x0e(0b1110) ->  3.000000
// 0x0f(0b1111) ->  3.285714

extern bool G_USBINT;

bool ReadFightingPad6B (char *devType, int *buttons);
bool ReadSS              (char *devType, int *buttons);
bool ReadFamicomJoycard(char *devType, int *buttons);
bool ReadKabutogani    (char *devType, int *buttons);
bool ReadPS              (char *devType, int *buttons);

void Set_AnalogAndHatValue
    (char right, char left, char up, char down);

unsigned char Get_HatSwitchVal
    (char right, char left, char up, char down);

#ifdef	__cplusplus
}
#endif

#endif	/* JOYSTICK_H */

